////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001-2023 Alexey Kuryakin daqgroup@mail.ru under MIT license //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// This file is part of the CRW-DAQ project by DaqGroup - component CRWKIT.   //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Purpose:                                                                   //
// Add [TextMetaData] section to INI,CFG files with checksum, date/time etc.  //
// Uses for file integrity checking in CRW-DAQ configurations.                //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// History:                                                                   //
// 20170222 - Created by A.K.                                                 //
// 20230524 - Modified for FPC (A.K.)                                         //
////////////////////////////////////////////////////////////////////////////////

program textmetadata;

{$I _crw_sysdef.inc}

{$I _crw_sysmode.inc}

{$R textmetadata.res}

uses
 //////////////////////////////////////////////////////
 {$I _crw_uses_first.inc} // NB: MUST BE FIRST USES !!!
 //////////////////////////////////////////////////////
 sysutils, classes,
 _crw_alloc, _crw_meta;

begin
 ExitCode:=TextMetaDataUtility(ParamStr(1),ParamStr(2),ParamStr(3));
end.

//////////////
// END OF FILE
//////////////

